"""
Test the Poi issue response form.
"""

import unittest

from plone.testing.z2 import Browser
from plone.app import testing as pa_testing

from retrans.poi import testing


class TestPoiCSVExport(unittest.TestCase):
    """
    Test the Poi issue response form.
    """

    layer = testing.RETRANS_POI_ISSUE_INTEGRATION_TESTING

    def setUpBrowser(self):
        """
        Start a logged in browser session.
        """
        app = self.layer['app']
        self.browser = Browser(app)
        self.browser.handleErrors = False  # Don't get HTTP 500 pages

        portal = self.layer['portal']
        portal_url = portal.absolute_url()

        self.browser.open(portal_url + '/login_form')
        self.browser.getControl(
            name='__ac_name').value = pa_testing.SITE_OWNER_NAME
        self.browser.getControl(
            name='__ac_password').value = pa_testing.SITE_OWNER_PASSWORD
        self.browser.getControl(name='submit').click()
        self.assertIn(
            "You are now logged in", self.browser.contents.decode('utf-8'),
            'Missing login confirmation message')

    def test_empty_content(self):
        """
        The empty tracker and issue have enough set up to work for tests.
        """
        tracker = self.layer['tracker']
        self.setUpBrowser()
        self.browser.open(tracker.absolute_url())
        self.browser.open(tracker['1'].absolute_url())

        self.assertIn(
            'complexity', self.browser.contents, 'Missing custom fields')
        self.assertIn(
            'Operations ROI - Estimated', self.browser.contents,
            'Exported CSV missing custom issue field')
